﻿Public Class MainModelBase
    Public Class MainModelBase(Of T As {MainModelBase(Of T), New}) : Inherits NotifyPropertyChange

        Private Shared _IsProvisionalStatic As Boolean
        Private Shared _Instance As T
        Public Shared ReadOnly Property Instance As T
            Get
                If _Instance Is Nothing Then
                    _IsProvisionalStatic = True
                    _Instance = New T
                    _IsProvisionalStatic = False
                End If
                Return _Instance
            End Get
        End Property


        Public Sub New()

            _Instance = DirectCast(Me, T)
        End Sub

    End Class

End Class
