﻿Imports Windows.UI

Public Class Pixel
    Private _brightness As Byte
    Private _color(2) As Byte

    Public Sub SetBrightness(value As Byte)
        _brightness = value
    End Sub

    Public Sub New(r As Byte, g As Byte, b As Byte)
        _color(0) = r
        _color(1) = g
        _color(2) = b
        ' _brightness = 255
    End Sub
    Public Sub New(color As Color)
        _color(0) = color.R
        _color(1) = color.G
        _color(2) = color.B
        ' _brightness = color.A
    End Sub

    Public Sub SetColor(r As Byte, g As Byte, b As Byte)
        _color(0) = r
        _color(1) = g
        _color(2) = b
        ' _brightness = 255
    End Sub
    Public Sub SetColor(color As Color)
        _color(0) = color.R
        _color(1) = color.G
        _color(2) = color.B
        '  _brightness = color.A
    End Sub
    Public Function GetColor() As Color
        Return Color.FromArgb(_brightness, _color(0), _color(1), _color(2))
    End Function
    Public Function GetColorRaw() As Byte()
        Try
            If _brightness = &HFF Then
                Return New Byte() {_color(0), _color(1), _color(2)}
            Else
                Return New Byte() {CByte(CInt(_color(0)) * CInt(_brightness) / &HFF),
                    CByte(CInt(_color(1)) * CInt(_brightness) / &HFF),
                    CByte(CInt(_color(2)) * CInt(_brightness) / &HFF)
                }
            End If
        Catch ex As Exception
            Debug.WriteLine("Error in GetColorRaw in Pixel: " + ex.Message)
        End Try
        Return New Byte() {0, 0, 0}
    End Function
End Class
