﻿Public Class TimespanToStringConverter : Implements IValueConverter

    Public Function Convert(value As Object, targetType As Type, parameter As Object, language As String) As Object Implements IValueConverter.Convert
        If value Is Nothing Then
            value = TimeSpan.FromSeconds(0)
        End If
        Dim val As Integer = CInt(DirectCast(value, TimeSpan).TotalSeconds)

        Return String.Format("{0:##0}:{1:00}", val \ 60, val Mod 60)
    End Function

    Public Function ConvertBack(value As Object, targetType As Type, parameter As Object, language As String) As Object Implements IValueConverter.ConvertBack
        Throw New NotImplementedException()
    End Function
End Class
