﻿Imports Windows.ApplicationModel.Core
Imports Windows.Storage
Imports Windows.Storage.Streams
Imports Windows.UI.Core

Public Class ImageData : Inherits BaseModel

    Public Event ShowMe(Image As ImageData)

    Property Sourcefile As StorageFile

    Public Sub New(source As StorageFile)
        Sourcefile = source
        Init()
    End Sub

    Public Property cmdShowMe() As New RelayCommand(Sub()
                                                        RaiseEvent ShowMe(Me)
                                                    End Sub, True)


    Private Async Sub Init()
        Imagedata = Await CreateBytestreams.GetBytestream(Sourcefile, 144, 40)


        Await CoreApplication.MainView.CoreWindow.Dispatcher.RunAsync(
     CoreDispatcherPriority.Normal, Sub()

                                        Dim i = New BitmapImage(New Uri(Sourcefile.Path))
                                        i.DecodePixelHeight = 50
                                        i.DecodePixelWidth = 50

                                        Image = i

                                    End Sub)


    End Sub

    Public Property Imagedata As Pixel(,)


    Public ReadOnly Property Name As String
        Get
            Return Sourcefile.DisplayName
        End Get
    End Property
    Private _image As BitmapImage
    Public Property Image() As BitmapImage
        Get
            Return _image
        End Get
        Set(ByVal value As BitmapImage)
            _image = value
            NotifyPropertyChanged()
        End Set
    End Property
End Class
