﻿Imports System.Xml.Serialization

Public Class Playerdata : Inherits BaseModel

    Public Event DisplayPlayer(Player As Playerdata)
    Public Event RemovePlayer(Player As Playerdata)
    <XmlIgnore>
    Public Property cmdRemovePlayer() As New RelayCommand(Async Sub()
                                                              Dim locationPromptDialog As ContentDialog = New ContentDialog With {.Title = "Frage",
                                                         .Content = "Spieler löschen?",
                                                         .CloseButtonText = "Abbruch",
                                                         .PrimaryButtonText = "Ok"
                                                             }
                                                              Dim result As ContentDialogResult = Await locationPromptDialog.ShowAsync()
                                                              If result = ContentDialogResult.Primary Then
                                                                  RaiseEvent RemovePlayer(Me)
                                                              End If
                                                          End Sub, True)

    <XmlIgnore>
    Public Property cmdDisplayPlayer() As New RelayCommand(Sub()
                                                               RaiseEvent DisplayPlayer(Me)
                                                           End Sub, True)

    Private _number As Integer
    Public Property Number() As Integer
        Get
            Return _number
        End Get
        Set(ByVal value As Integer)
            _number = value
            NotifyPropertyChanged()
        End Set
    End Property

    Private _Name As String
    Public Property Name() As String
        Get
            Return _Name
        End Get
        Set(ByVal value As String)
            _Name = value
            NotifyPropertyChanged()
        End Set
    End Property

    Public Property PositionName As ObservableCollection(Of String) = Positions.GetPosition

    Private _Position As String
    Public Property Position() As String
        Get
            Return _Position
        End Get
        Set(ByVal value As String)
            _Position = value
            NotifyPropertyChanged()
        End Set
    End Property
End Class
