﻿
Public Class MenuItem
    Public Property Icon() As Symbol
        Get
            Return m_Icon
        End Get
        Set
            m_Icon = Value
        End Set
    End Property
    Private m_Icon As Symbol
    Public Property Name() As String
        Get
            Return m_Name
        End Get
        Set
            m_Name = Value
        End Set
    End Property
    Private m_Name As String
    Public Property PageType() As Type
        Get
            Return m_PageType
        End Get
        Set
            m_PageType = Value
        End Set
    End Property
    Private m_PageType As Type

    Public Shared Function GetMainItems() As List(Of MenuItem)
        Dim items = New List(Of MenuItem)()
        items.Add(New MenuItem() With {
            .Icon = Symbol.GoToStart,
            .Name = "Main",
        .PageType = GetType(Main)
        })
        items.Add(New MenuItem() With {
            .Icon = Symbol.People,
            .Name = "Teams",
        .PageType = GetType(Teamdisplay)
        })
        items.Add(New MenuItem() With {
            .Icon = Symbol.Folder,
            .Name = "Fonts",
        .PageType = GetType(Fonts)
        })
        items.Add(New MenuItem() With {
            .Icon = Symbol.Pictures,
            .Name = "Pictures",
        .PageType = GetType(Pictures)
        })
        items.Add(New MenuItem() With {
            .Icon = Symbol.Video,
            .Name = "Videos",
           .PageType = GetType(Videos)
         })

        Return items
    End Function

    Public Shared Function GetOptionsItems() As List(Of MenuItem)
        Dim items = New List(Of MenuItem)()
        items.Add(New MenuItem() With {
            .Icon = Symbol.Setting,
            .Name = "Einstellungen",
            .PageType = GetType(Options)
        })
        Return items
    End Function
End Class

